//#include "StdAfx.h"
#include "subjectwriter.h"
#include <stdio.h>
#include <assert.h>
#include <errno.h>

#define PADSTR ")   "

//RAMDISKgꍇ͂̃pXĂB
const char backpath[] = "back_subject.txt";
const char frontpath[] = "subject.txt";

#define MUTEXNAME "subject.txt xxxx"

CSubjectWriter::CSubjectWriter(void)
{
	fb = NULL;

	hMutex = ::CreateMutex(NULL, TRUE, MUTEXNAME);
	if (!hMutex) 
		puts("Can't Create Mutex Object");
}

CSubjectWriter::~CSubjectWriter(void)
{
	if (fb)
		fclose(fb);

	CloseHandle(hMutex);
}


bool CSubjectWriter::WriteSubject(const char* path, datlist& subject)
{
	int		fpos = 0;//t@C̃CfbNX
	char	numbuf[7];
	size_t	figure;
	
	itrdatlist p = subject.begin();

	if (fb) 
		fclose(fb);
	
	fb = fopen(path, "wb");
	if (!fb) {
		puts("can't open file");
		return false;
	}

	for (int i=0; i < subject.size(); ++i, ++p) {
		char datname[15];

		//sprintf(datname, "%d.dat", p->number);
		itoa(p->number, datname, 10);
		strcat(datname, ".dat");
		
		fputs(datname, fb);
		fputs("<>", fb);
		fputs(p->title, fb);
		fputs(" (", fb);
		fpos += strlen(datname) + 2 + strlen(p->title) + 2;

		//ŏʒuL
		vfidx.at(i) = fpos;

		//X̏o
		//sprintf(numbuf, "%d", p->nres);
		itoa(p->nres, numbuf, 10);
		figure = strlen(numbuf);

		//pbfBO
		memcpy(numbuf + figure, PADSTR, 4+1 - figure);//4 = , 1 = ')'̕
		numbuf[4+1] = '\n';
		numbuf[4+2] = '\0';
		fputs(numbuf, fb);

		fpos += 4/**/ +1/*')'*/ +1;/*'\n'*/
	}
	fclose(fb);
	fb = NULL;
	return true;
}


bool CSubjectWriter::UpdateResCount(int datpos/*ォ牽Ԗ*/, int nres)
{
	char	numbuf[6];
	size_t	figure;

	assert(fb);

	//X̏o
	//sprintf(numbuf, "%d", nres);
	itoa(nres, numbuf, 10);

	figure = strlen(numbuf);

	//pbfBO
	memcpy(numbuf + figure, PADSTR, 4+1 - figure);//4 = , 1 = ')'̕
	
	fseek(fb, vfidx.at(datpos), SEEK_SET);
	//assert( == 0);

	//bN
	if (WaitForSingleObject(hMutex, INFINITE) != WAIT_OBJECT_0) {
		puts("mutex error");
		return false;
	}
	fwrite(numbuf, sizeof(char), 5, fb);
	fflush(fb);

	//AbN
	ReleaseMutex(hMutex);

	return true;
}


bool CSubjectWriter::UpdateSubject(datlist& subject)
{

	vfidx.clear();
	vfidx.resize(subject.size());

	if (!WriteSubject(backpath, subject))
		return false;

	//bN
	if (WaitForSingleObject(hMutex, INFINITE) != WAIT_OBJECT_0) {
		puts("mutex error");
		return false;
	}
	if (remove(frontpath) && errno != ENOENT) {
		puts("can't remove file");
		ReleaseMutex(hMutex);
		return false;
	}

	if (rename(backpath, frontpath)) {
		puts("can't rename file");
		ReleaseMutex(hMutex);
		return false;
	}

	fb = fopen(frontpath, "r+b");
	if (!fb) {
		puts("can't open file");
		ReleaseMutex(hMutex);
		return false;
	}

	ReleaseMutex(hMutex);
    return true;
}